SystemOrganization addCategory: #'GT-PetitParserDebugger'!

DebugSession subclass: #GTPPDebugSession
	instanceVariableNames: 'rootParserContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPDebugSession methodsFor: 'predicates creation' stamp: 'AndreiChis 8/14/2013 18:01'!
createStepPredicateForPredicate: aPredicate 

	^ self createStepPredicateForPredicate: aPredicate fromContext: rootParserContext
	! !

!GTPPDebugSession methodsFor: 'testing' stamp: 'AndreiChis 8/14/2013 18:00'!
isActive

	^ self isActive: rootParserContext! !

!GTPPDebugSession methodsFor: 'testing' stamp: 'AndreiChis 8/14/2013 18:00'!
isActive: aContext

	^ aContext 
		ifNil: [ false ] 
		ifNotNil: [ 
			aContext isDead not and: [
				aContext ~= self process suspendedContext or: [aContext willReturn not ] ] ]! !

!GTPPDebugSession methodsFor: 'testing' stamp: 'AndreiChis 8/7/2013 18:30'!
isPPParser: anObject 

	^ self isPPParserClass: anObject class
	! !

!GTPPDebugSession methodsFor: 'testing' stamp: 'AndreiChis 8/7/2013 14:24'!
isPPParserClass: aClass

	^ aClass inheritsFrom: PPParser 

	! !

!GTPPDebugSession methodsFor: 'testing' stamp: 'AndreiChis 9/3/2014 14:23'!
isPPProduction: anObject 

	^ (anObject class includesBehavior: PPDelegateParser ) and: [ 
			anObject name notNil ]
	! !

!GTPPDebugSession methodsFor: 'predicates' stamp: 'AndreiChis 9/3/2014 14:17'!
namedProductionPredicate: anObject
	""
	
	^ self createPredicateForBlock: [ :aContext |
		(self isPPProduction: aContext receiver) and: [ 
			anObject isNil or: [ 
				aContext receiver name = anObject ] ] ]! !

!GTPPDebugSession methodsFor: 'predicates' stamp: 'AndreiChis 8/7/2013 18:45'!
notDelegateParserClassPredicate

	^ self createPredicateForBlock: [ :aContext |
		(self isPPParser: aContext receiver) and: [ 
			aContext receiver class ~= PPDelegateParser ] ]! !

!GTPPDebugSession methodsFor: 'predicates' stamp: 'AndreiChis 8/7/2013 18:29'!
parseMethodEntryPredicate

	^ self createPredicateForBlock: [ :aContext |
			(self isPPParser: aContext receiver) and: [ 
				aContext selector = #parseOn: and: [ 
					aContext isInitialnstruction ] ] ]! !

!GTPPDebugSession methodsFor: 'predicates' stamp: 'AndreiChis 8/7/2013 18:29'!
parseMethodPredicate

	^ self createPredicateForBlock: [ :aContext |
			(self isPPParser: aContext receiver) and: [ 
				aContext selector = #parseOn: ] ]! !

!GTPPDebugSession methodsFor: 'initialization' stamp: 'AndreiChis 7/17/2013 23:09'!
process: aProcess context: aContext

	super process: aProcess context: aContext.
	
	self flag: 'Have a method that is only called when the session is created and put this there'.
	rootParserContext ifNil:  [
		rootParserContext := aContext locateRootPPParser]! !

!GTPPDebugSession methodsFor: 'accessing' stamp: 'AndreiChis 9/10/2014 18:48'!
rootParser
	^ (rootParserContext tempAt: 1) debugRoot! !

!GTPPDebugSession methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 18:24'!
rootParserContext

	^ rootParserContext! !

!GTPPDebugSession methodsFor: 'debugging actions' stamp: 'AndreiChis 7/17/2013 22:53'!
stepOverInitialInstructionForContext: aContext
	
	(self isActive and: [
		self parseMethodEntryPredicate matches: aContext ])  
			ifTrue: [ self stepInto ]
	! !

!GTPPDebugSession methodsFor: 'debugging actions' stamp: 'AndreiChis 8/26/2013 11:49'!
stepToNextNonDelegateParserFromContext: aContext

	self 
		stepUntil: (self parseMethodEntryPredicate and: self notDelegateParserClassPredicate)
		from: aContext! !

!GTPPDebugSession methodsFor: 'debugging actions' stamp: 'AndreiChis 8/26/2013 11:49'!
stepToNextParserFromContext: aContext

	self 
		stepUntil: self parseMethodEntryPredicate
		from: aContext! !

!GTPPDebugSession methodsFor: 'debugging actions' stamp: 'AndreiChis 8/26/2013 11:49'!
stepToNextProduction: aProduction fromContext: aContext
	
	self 
		stepUntil: (self parseMethodEntryPredicate and: (self namedProductionPredicate: aProduction)) 
		from: aContext! !

!GTPPDebugSession methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 11:30'!
stream

	^ self streamFromContext: rootParserContext! !

!GTPPDebugSession methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 11:30'!
streamFromContext: aContext

	^ aContext tempAt: 1! !

!Context methodsFor: '*GT-PetitParserDebugger' stamp: 'AndreiChis 1/5/2015 17:14'!
isPPParseMethodContext
	
	^ (self receiver class inheritsFrom: PPParser) and: [ 
		self selector = #parseOn: ] 
	
	
! !

!Context methodsFor: '*GT-PetitParserDebugger' stamp: 'AndreiChis 1/5/2015 17:14'!
isPPParseRootMethodContext
	
	^ (self receiver class inheritsFrom: PPParser) and: [ 
		self selector = #parse: ] 
	
	
! !

!Context methodsFor: '*GT-PetitParserDebugger' stamp: 'AndreiChis 1/5/2015 17:14'!
locateRootPPParser
	"Find the last context starting from the top of the stack (or the first starting from the bottom of the stack)
	that was created by a PPParser"
	| parserContext currentContext |

	parserContext := nil.
	currentContext := self.
	[ 
		(currentContext := currentContext locateTopPPParser) notNil
	 ] whileTrue: [ 
		parserContext := currentContext.
		currentContext := currentContext sender ].

	^ parserContext! !

!Context methodsFor: '*GT-PetitParserDebugger' stamp: 'AndreiChis 1/5/2015 17:14'!
locateTopNamedPPParser
	
	^ self findContextSuchThat:  [ :ctx | 
		ctx isPPParseMethodContext and: [ 
			(ctx receiver class includesBehavior: PPDelegateParser) and: [  
					ctx receiver name notNil ] ] ]
	
	
! !

!Context methodsFor: '*GT-PetitParserDebugger' stamp: 'AndreiChis 1/5/2015 17:14'!
locateTopPPParser
	"Find the first context, starting from the top the stack that was created by a PPParser. "
	
	^ self findContextSuchThat:  [ :ctx | 
		ctx isPPParseMethodContext ]
	
	
! !

DebugAction subclass: #GTPPDebugAction
	instanceVariableNames: 'startContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPDebugAction methodsFor: 'testing' stamp: 'AndreiChis 8/14/2013 18:16'!
appliesToContext: aContext

	^ self session isActive and: [
		aContext locateTopPPParser notNil ]! !

!GTPPDebugAction methodsFor: 'accessing' stamp: 'AndreiChis 8/6/2013 14:18'!
startContext

	^ startContext ifNil: [ self currentContext ]! !

!GTPPDebugAction methodsFor: 'accessing' stamp: 'AndreiChis 7/17/2013 23:33'!
startContext: aContext

	startContext := aContext! !

GTPPDebugAction subclass: #GTPPStepToNextFailureAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPStepToNextFailureAction class methodsFor: 'registration' stamp: 'AndreiChis 8/14/2013 14:32'!
gtActionType
	<gtPPDebuggingAction>
	<gtContextPPDebuggingAction>! !

!GTPPStepToNextFailureAction methodsFor: 'accessing' stamp: 'AndreiChis 9/11/2014 19:45'!
defaultIcon 
	
	^ GLMUIThemeExtraIcons glamourousNextFailure! !

!GTPPStepToNextFailureAction methodsFor: 'accessing' stamp: 'AndreiChis 3/27/2016 20:22'!
defaultLabel 
	
	^ 'Next failure'! !

!GTPPStepToNextFailureAction methodsFor: 'accessing' stamp: 'AndreiChis 12/9/2013 22:46'!
defaultOrder
	^ 200! !

!GTPPStepToNextFailureAction methodsFor: 'actions' stamp: 'AndreiChis 8/26/2013 11:50'!
executeAction

	self session
		stepUntil: (self isPPFailureFollowingPredicate) from: self startContext.
	(self session isActive and: [ 
		self isPPFailureFollowingPredicate matches: self session context ]) ifTrue: [ 
			self session 
				stepOver;
				stepOver;
				stepOver ]! !

!GTPPStepToNextFailureAction methodsFor: 'predicates' stamp: 'AndreiChis 9/3/2014 15:29'!
isPPFailureFollowingPredicate

	^ self session createPredicateForBlock: [ :aContext |
		aContext methodClass = PPFailure class and: [ 
			aContext selector = #message:context: ] ] ! !

GTPPDebugAction subclass: #GTPPStepToNextNamedProductionAction
	instanceVariableNames: 'production'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPStepToNextNamedProductionAction class methodsFor: 'private' stamp: 'AndreiChis 8/14/2013 14:45'!
allParserSuperclassesFor: aClass
	|  allSuperclasses  |

	allSuperclasses := aClass withAllSuperclasses.
	"Return 2 in the ifAbsent: block so that if PPCompositeParser is not a superclass only the current class is returned"
	^ allSuperclasses copyFrom: 1 to: (allSuperclasses indexOf: PPCompositeParser ifAbsent: [ 2 ]) - 1
		! !

!GTPPStepToNextNamedProductionAction class methodsFor: 'registration' stamp: 'AndreiChis 3/27/2016 20:21'!
gtToNextProductionActionFor: aDebugger
	<gtPPDebuggingAction>
	<gtContextPPDebuggingAction>

	^ (self forDebugger: aDebugger)
		production: nil;
		label: 'Next production';
		category: 'Next parser invocation';
		icon: GLMUIThemeExtraIcons glamourousNextProduction;
		order: 195! !

!GTPPStepToNextNamedProductionAction class methodsFor: 'registration' stamp: 'AndreiChis 12/9/2013 22:45'!
gtToProductionActionFor: aDebugger
	<gtPPDebuggingAction>
	<gtContextPPDebuggingAction>
	| order allParserSuperclasses showedProductions actions |

	order := 500.
	actions := OrderedCollection new.
	showedProductions := OrderedCollection new.

	(allParserSuperclasses := self allParserSuperclassesFor: aDebugger session rootParser class) do: [ :each |
		| productions |
		productions := (aDebugger productionSelectorsFrom: each) copyWithoutAll: showedProductions.
		showedProductions addAll: productions.
		
		actions addAll: (productions collect: [ :aProduction |
			(self forDebugger: aDebugger)
				production: aProduction;
				label: aProduction asString;
				category: 'Next production', (allParserSuperclasses size = 1 ifTrue:[ '' ] ifFalse:[ ' [', each name, ']']);
				order: (order := order + 1) ]) ].
		
	^ actions ! !

!GTPPStepToNextNamedProductionAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 23:06'!
defaultProduction

	^ nil! !

!GTPPStepToNextNamedProductionAction methodsFor: 'actions' stamp: 'AndreiChis 8/7/2013 19:00'!
executeAction
	
	self session 
		stepOverInitialInstructionForContext: self startContext;
		stepToNextProduction: self production fromContext: self startContext! !

!GTPPStepToNextNamedProductionAction methodsFor: 'accessing' stamp: 'AndreiChis 9/9/2013 11:03'!
production
	
	^ production ifNil: [ self defaultProduction ]! !

!GTPPStepToNextNamedProductionAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 18:59'!
production: anObject
	
	production := anObject! !

GTPPStepToNextNamedProductionAction subclass: #GTPPStepToSameNamedProductionAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPStepToSameNamedProductionAction class methodsFor: 'registration' stamp: 'AndreiChis 8/7/2013 23:21'!
gtActionType
	<gtPPDebuggingAction>
	<gtContextPPDebuggingAction>

	! !

!GTPPStepToSameNamedProductionAction methodsFor: 'testing' stamp: 'AndreiChis 9/3/2014 14:17'!
appliesToContext: aContext

	^ (super appliesToContext: aContext) and: [ 
		self session isPPProduction: aContext receiver ]! !

!GTPPStepToSameNamedProductionAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 23:21'!
defaultCategory

	^ 'Next parser invocation'! !

!GTPPStepToSameNamedProductionAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 23:20'!
defaultLabel

	^ 'same production'! !

!GTPPStepToSameNamedProductionAction methodsFor: 'accessing' stamp: 'AndreiChis 12/9/2013 22:53'!
defaultOrder

	^ 204! !

!GTPPStepToSameNamedProductionAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 23:17'!
defaultProduction

	^ self currentContext receiver name! !

GTPPDebugAction subclass: #GTPPStepToNextNonDelegateParserAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPStepToNextNonDelegateParserAction class methodsFor: 'registration' stamp: 'AndreiChis 8/7/2013 18:33'!
gtActionType
	<gtPPDebuggingAction>
	<gtContextPPDebuggingAction>! !

!GTPPStepToNextNonDelegateParserAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 20:28'!
defaultCategory
	
	^ 'Next parser invocation'! !

!GTPPStepToNextNonDelegateParserAction methodsFor: 'accessing' stamp: 'AndreiChis 12/9/2013 22:51'!
defaultLabel 
	
	^ 'any primitive parser'! !

!GTPPStepToNextNonDelegateParserAction methodsFor: 'accessing' stamp: 'AndreiChis 12/9/2013 22:50'!
defaultOrder

	^ 201! !

!GTPPStepToNextNonDelegateParserAction methodsFor: 'actions' stamp: 'AndreiChis 8/5/2013 17:37'!
executeAction	

	self session 
		stepOverInitialInstructionForContext: self startContext;
		stepToNextNonDelegateParserFromContext: self startContext
! !

GTPPDebugAction subclass: #GTPPStepToNextParserAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPStepToNextParserAction class methodsFor: 'registration' stamp: 'AndreiChis 8/7/2013 18:33'!
gtActionType
	<gtPPDebuggingAction>
	<gtContextPPDebuggingAction>! !

!GTPPStepToNextParserAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 20:30'!
defaultCategory

	^ 'Next parser invocation'! !

!GTPPStepToNextParserAction methodsFor: 'accessing' stamp: 'AndreiChis 9/11/2014 19:40'!
defaultIcon

	^ GLMUIThemeExtraIcons glamourousNextParser! !

!GTPPStepToNextParserAction methodsFor: 'accessing' stamp: 'AndreiChis 3/27/2016 20:21'!
defaultLabel 

	^ 'Next parser'! !

!GTPPStepToNextParserAction methodsFor: 'accessing' stamp: 'AndreiChis 9/11/2014 19:50'!
defaultOrder

	^ 190! !

!GTPPStepToNextParserAction methodsFor: 'actions' stamp: 'AndreiChis 8/5/2013 17:12'!
executeAction
	
	self session 
		stepOverInitialInstructionForContext: self startContext;
		stepToNextParserFromContext: self startContext! !

GTPPDebugAction subclass: #GTPPStepToNextStreamPositionAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPStepToNextStreamPositionAction class methodsFor: 'registration' stamp: 'AndreiChis 3/14/2016 15:43'!
gtNextStreamUpdateActionFor: aDebugger
	<gtPPStreamDebuggingAction>
	<gtContextPPStreamDebuggingAction>
	
	^ (self forDebugger: aDebugger)
		label: 'Run to next update';
		icon: GLMUIThemeExtraIcons glamorousInto! !

!GTPPStepToNextStreamPositionAction methodsFor: 'actions' stamp: 'AndreiChis 8/26/2013 11:50'!
executeAction
	| currentPosition |

	currentPosition := self session stream position.
	self session
		stepUntil: (self streamToDifferentPositionThan: currentPosition) from: self startContext.! !

!GTPPStepToNextStreamPositionAction methodsFor: 'predicates' stamp: 'AndreiChis 8/13/2013 18:07'!
streamToDifferentPositionThan: anInteger

	^ self session createPredicateForBlock: [
		self session stream position ~= anInteger ]! !

GTPPDebugAction subclass: #GTPPStepToParserTypeAction
	instanceVariableNames: 'parserClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPStepToParserTypeAction class methodsFor: 'registration' stamp: 'AndreiChis 12/9/2013 22:47'!
gtActionFor: aDebugger
	<gtPPDebuggingAction>
	<gtContextPPDebuggingAction>
	|order|
	
	order := 300.
	^ self parserTypes collect: [ :each |
		(self forDebugger: aDebugger)
			parserClass: each;
			label: each name;
			category: 'Next parser type';
			order: (order := order + 1) ]! !

!GTPPStepToParserTypeAction class methodsFor: 'private' stamp: 'AndreiChis 8/7/2013 23:41'!
parserTypes

	^ { 
		PPDelegateParser. 
		PPActionParser. 
		PPWrappingParser. 
		PPAndParser. 
		PPEndOfInputParser. 
		PPFlattenParser. 
		PPTokenParser. 
		PPMemoizedParser. 
		PPNotParser. 
		PPOptionalParser. 
		PPGreedyRepeatingParser. 
		PPLazyRepeatingParser. 
		PPPossessiveRepeatingParser. 
		PPTrimmingParser. 
		PPEpsilonParser. 
		PPFailingParser. 
		PPChoiceParser. 
		PPSequenceParser. 
		PPLiteralObjectParser. 
		PPLiteralSequenceParser. 
		PPPluggableParser. 
		PPPredicateObjectParser. 
		PPPredicateSequenceParser
	}! !

!GTPPStepToParserTypeAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 23:52'!
defaultParserClass

	^ nil! !

!GTPPStepToParserTypeAction methodsFor: 'actions' stamp: 'AndreiChis 8/26/2013 11:50'!
executeAction

	self session
		stepOverInitialInstructionForContext: self startContext;
		stepUntil: self sameParserTypePredicate from: self startContext.! !

!GTPPStepToParserTypeAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 23:52'!
parserClass

	^ parserClass ifNil: [ self defaultParserClass ]! !

!GTPPStepToParserTypeAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 23:37'!
parserClass: aClass 

	parserClass := aClass! !

!GTPPStepToParserTypeAction methodsFor: 'predicates' stamp: 'AndreiChis 8/7/2013 23:37'!
sameParserClassPredicate

	^ self session createPredicateForBlock: [ :aContext |
		aContext receiver class == self parserClass ]! !

!GTPPStepToParserTypeAction methodsFor: 'predicates' stamp: 'AndreiChis 8/6/2013 14:27'!
sameParserTypePredicate

	^ self session parseMethodEntryPredicate and: self sameParserClassPredicate! !

GTPPStepToParserTypeAction subclass: #GTPPStepToSameParserTypeAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPStepToSameParserTypeAction class methodsFor: 'registration' stamp: 'AndreiChis 8/8/2013 00:15'!
gtActionType
	<gtPPDebuggingAction>
	<gtContextPPDebuggingAction>! !

!GTPPStepToSameParserTypeAction methodsFor: 'testing' stamp: 'AndreiChis 8/7/2013 23:43'!
appliesToContext: aContext

	^ (super appliesToContext: aContext) and: [ 
		aContext receiver class inheritsFrom: PPParser ]! !

!GTPPStepToSameParserTypeAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 23:47'!
defaultCategory

	^ 'Next parser invocation'! !

!GTPPStepToSameParserTypeAction methodsFor: 'accessing' stamp: 'AndreiChis 12/9/2013 22:53'!
defaultLabel 

	^ 'same parser type'! !

!GTPPStepToSameParserTypeAction methodsFor: 'accessing' stamp: 'AndreiChis 12/9/2013 22:53'!
defaultOrder

	^ 205! !

!GTPPStepToSameParserTypeAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 23:53'!
defaultParserClass

	^ self currentContext receiver class! !

GTPPDebugAction subclass: #GTPPStepToSameParserAction
	instanceVariableNames: 'parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPStepToSameParserAction class methodsFor: 'registration' stamp: 'AndreiChis 12/9/2013 22:53'!
gtActionFor: aDebugger
"	<gtPPDebuggingAction>
	<gtContextPPDebuggingAction>
	"
	^ (self forDebugger: aDebugger)
		parser: aDebugger currentContext receiver! !

!GTPPStepToSameParserAction methodsFor: 'testing' stamp: 'AndreiChis 7/17/2013 23:39'!
appliesToContext: aContext

	^ (super appliesToContext: aContext) and: [ 
		aContext receiver class inheritsFrom: PPParser ]! !

!GTPPStepToSameParserAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 20:30'!
defaultCategory

	^ 'Next parser invocation'! !

!GTPPStepToSameParserAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 20:30'!
defaultLabel 

	^ 'same parser'! !

!GTPPStepToSameParserAction methodsFor: 'accessing' stamp: 'AndreiChis 8/7/2013 23:17'!
defaultOrder

	^ 30! !

!GTPPStepToSameParserAction methodsFor: 'actions' stamp: 'AndreiChis 8/26/2013 11:50'!
executeAction

	self session
		stepOverInitialInstructionForContext: self startContext;
		stepUntil: self sameParserPredicate from: self startContext.! !

!GTPPStepToSameParserAction methodsFor: 'accessing' stamp: 'AndreiChis 7/17/2013 16:40'!
parser

	^ parser! !

!GTPPStepToSameParserAction methodsFor: 'accessing' stamp: 'AndreiChis 7/17/2013 16:40'!
parser: anObject

	parser := anObject! !

!GTPPStepToSameParserAction methodsFor: 'predicates' stamp: 'AndreiChis 8/6/2013 14:10'!
sameParserObjectPredicate

	^ self session createPredicateForBlock: [ :aContext |
		aContext receiver == self parser ]! !

!GTPPStepToSameParserAction methodsFor: 'predicates' stamp: 'AndreiChis 8/5/2013 17:41'!
sameParserPredicate

	^ self session parseMethodEntryPredicate and: self sameParserObjectPredicate! !

GTPPDebugAction subclass: #GTPPStepToStreamPositionAction
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPStepToStreamPositionAction class methodsFor: 'registration' stamp: 'AndreiChis 3/14/2016 15:44'!
gtSelectedStreamPositionActionFor: aDebugger
	<gtPPStreamDebuggingAction>
	<gtContextPPStreamDebuggingAction>
	
	^ (self forDebugger: aDebugger)
		position: aDebugger streamSelectionInterval last;
		label: 'Run to here'! !

!GTPPStepToStreamPositionAction methodsFor: 'actions' stamp: 'AndreiChis 8/26/2013 11:50'!
executeAction
	| currentPosition targetPosition |

	currentPosition := self session stream position.
	targetPosition := self position 
		ifNil: [ currentPosition + 1 ]
		ifNotNil: [ :anInteger | anInteger ].
		
	self session
		stepUntil: (self streamToPosition: targetPosition) from: self startContext.! !

!GTPPStepToStreamPositionAction methodsFor: 'accessing' stamp: 'AndreiChis 8/8/2013 11:24'!
position
	
	^ position! !

!GTPPStepToStreamPositionAction methodsFor: 'accessing' stamp: 'AndreiChis 8/8/2013 11:30'!
position: anInteger
	
	position := anInteger! !

!GTPPStepToStreamPositionAction methodsFor: 'predicates' stamp: 'AndreiChis 8/14/2013 10:11'!
streamToPosition: anInteger

	^ self session createPredicateForBlock: [
		self session stream position = anInteger ]! !

GTPPDebugAction subclass: #GTPPWhereIsStreamAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPWhereIsStreamAction class methodsFor: 'registration' stamp: 'AndreiChis 8/8/2013 11:45'!
gtActionType
	<gtPPStreamDebuggingAction>! !

!GTPPWhereIsStreamAction methodsFor: 'accessing' stamp: 'AndreiChis 8/8/2013 11:36'!
defaultIcon
	
	^ GLMUIThemeExtraIcons glamorousSearch! !

!GTPPWhereIsStreamAction methodsFor: 'accessing' stamp: 'AndreiChis 8/8/2013 11:36'!
defaultLabel 
	
	^ 'Where is stream?'! !

!GTPPWhereIsStreamAction methodsFor: 'actions' stamp: 'AndreiChis 8/8/2013 11:42'!
executeAction

	self debugger updateStreamSelectionInterval! !

!GTPPWhereIsStreamAction methodsFor: 'initialization' stamp: 'AndreiChis 11/25/2015 16:43'!
initialize 
	super initialize.
	self needsUpdate: false! !

DebugAction subclass: #GTPPStepToPPDebugger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPStepToPPDebugger class methodsFor: 'registration' stamp: 'AndreiChis 1/20/2015 22:03'!
gtActionType
	<gtDebuggingAction>! !

!GTPPStepToPPDebugger methodsFor: 'testing' stamp: 'AndreiChis 8/20/2013 18:38'!
appliesToContext: aContext
	self flag: 'A better mechanism for determining if an action is active or not is needed.'.
	
	^ self debugger class ~= self debuggerClass! !

!GTPPStepToPPDebugger methodsFor: 'accessing' stamp: 'AndreiChis 8/20/2013 18:33'!
debuggerClass
	
	^ GTPPDebugger! !

!GTPPStepToPPDebugger methodsFor: 'accessing' stamp: 'AndreiChis 8/14/2013 18:04'!
defaultCategory
	
	^ 'Step to debugger'! !

!GTPPStepToPPDebugger methodsFor: 'accessing' stamp: 'AndreiChis 8/20/2013 18:33'!
defaultLabel 
	
	^ self debuggerClass defaultTitle! !

!GTPPStepToPPDebugger methodsFor: 'accessing' stamp: 'AndreiChis 12/29/2013 17:09'!
defaultOrder

	^ 150! !

!GTPPStepToPPDebugger methodsFor: 'actions' stamp: 'AndreiChis 8/26/2013 12:00'!
executeAction

	self session
		stepUntil: (self session 
			createStepPredicateForPredicate: self isPPDebuggerActivePredicate 
			fromContext: self currentContext ) 
		from: self currentContext.
		
	(self isPPDebuggerActivePredicate matches: self interruptedContext) ifTrue: [ 
		self debugger debug: self interruptedContext using: self debuggerClass ]
! !

!GTPPStepToPPDebugger methodsFor: 'accessing' stamp: 'AndreiChis 10/2/2018 19:01'!
help 
	^ 'Open the PetitParser Debugger'! !

!GTPPStepToPPDebugger methodsFor: 'as yet unclassified' stamp: 'AndreiChis 11/25/2015 16:37'!
initialize 
	super initialize.
	
	self needsUpdate: false! !

!GTPPStepToPPDebugger methodsFor: 'testing' stamp: 'AndreiChis 8/20/2013 18:35'!
isPPDebuggerActivePredicate

	^ self session createPredicateForBlock: [ :aContext |
		aContext isPPParseMethodContext ]! !

!PPCompositeParser class methodsFor: '*GT-PetitParserDebugger' stamp: 'AndreiChis 8/13/2013 17:46'!
productionSelectors

	^ (((self allInstVarNames copyWithoutAll: self ignoredNames)
		collect: [ :each | each asSymbol ])
			select: [ :each | self includesSelector: each ]) asSortedCollection add: #start; yourself! !

GTDebuggerSmokeTest subclass: #GTPPDebuggerSmokeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPDebuggerSmokeTest methodsFor: 'accessing' stamp: 'AndreiChis 12/17/2013 15:20'!
debuggerToTest

	^ GTPPDebugger! !

!GTPPDebuggerSmokeTest methodsFor: 'tests' stamp: 'AndreiChis 8/28/2014 12:00'!
expectedFailures
	^ #(testDebugger)! !

!GTPPDebuggerSmokeTest methodsFor: 'utils' stamp: 'AndreiChis 1/22/2016 20:00'!
stepToParseOnContext
	"Step through the execution until the process reaches a context 
	that can be handles using the PetitParser debugger"
	
	^ [ :aProcess |
	aProcess 
		step;
		step;
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		step;
		step;
		step; "send the message 'parse:' "
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		step. "send the message parseOn: "
		aProcess stepToSendOrReturn ]! !

!GTPPDebuggerSmokeTest methodsFor: 'tests' stamp: 'AndreiChis 1/22/2016 20:00'!
testDebugger

	self 
		assertDebuggerInitializationForContext: [PPArithmeticParser new parse: '1+1'] asContext 
		andStepBlock: self stepToParseOnContext.

 	self assertDebuggerClosing.! !

GTReflectivityDebugAction subclass: #GTPPReflectivityStepDebugAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPReflectivityStepDebugAction methodsFor: 'testing' stamp: 'AndreiChis 9/7/2017 13:59'!
appliesToContext: aContext

	^ self session isActive and: [
		aContext locateTopPPParser notNil ]! !

!GTPPReflectivityStepDebugAction methodsFor: 'accessing' stamp: 'AndreiChis 9/7/2017 13:59'!
debuggerClass
	^ GTPPDebugger! !

GTPPReflectivityStepDebugAction subclass: #GTPPStepToNextProductionReflectivityAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPStepToNextProductionReflectivityAction class methodsFor: 'registration' stamp: 'AndreiChis 9/7/2017 22:38'!
gtToNextProductionAction
	"<gtPPDebuggingAction>
	<gtContextPPDebuggingAction>"! !

!GTPPStepToNextProductionReflectivityAction methodsFor: 'accessing' stamp: 'AndreiChis 9/7/2017 23:13'!
attachBreakpoints
		
	self beforeMethodBreakpoint
		targetMethod: PPDelegateParser>>#parseOn:! !

!GTPPStepToNextProductionReflectivityAction methodsFor: 'initialization' stamp: 'AndreiChis 9/7/2017 14:51'!
initialize
	super initialize.
	self 
		label: 'Next production';
		category: 'Next parser invocation (fast)';
		"icon: GLMUIThemeExtraIcons glamourousNextProduction;"
		order: 195! !

GTPPReflectivityStepDebugAction subclass: #GTPPStepToStreamPositionChangedReflectivityAction
	instanceVariableNames: 'initialPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPStepToStreamPositionChangedReflectivityAction class methodsFor: 'registration' stamp: 'AndreiChis 9/7/2017 22:38'!
gtStreamPositionChangedActionFor: aDebugger
	"<gtPPStreamDebuggingAction>
	<gtContextPPStreamDebuggingAction>"
	
	^ (self forDebugger: aDebugger)
		label: 'Run to next update (fast)';
		icon: GLMUIThemeExtraIcons glamorousInto;
		initialPosition: aDebugger session stream position! !

!GTPPStepToStreamPositionChangedReflectivityAction methodsFor: 'actions' stamp: 'AndreiChis 9/7/2017 23:13'!
attachBreakpoints

	self afterMethodBreakpoint
		targetMethod: PPContext>>#next;
		whenReceiver: [ :aPPContext | aPPContext position ~= self initialPosition ]! !

!GTPPStepToStreamPositionChangedReflectivityAction methodsFor: 'accessing' stamp: 'AndreiChis 3/14/2016 15:25'!
initialPosition

	^ initialPosition! !

!GTPPStepToStreamPositionChangedReflectivityAction methodsFor: 'accessing' stamp: 'AndreiChis 3/14/2016 15:27'!
initialPosition: anInteger

	initialPosition := anInteger! !

GTPPReflectivityStepDebugAction subclass: #GTPPStepToStreamPositionReflectivityAction
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPStepToStreamPositionReflectivityAction class methodsFor: 'registration' stamp: 'AndreiChis 9/7/2017 22:38'!
gtSelectedStreamPositionActionFor: aDebugger
	"<gtPPStreamDebuggingAction>
	<gtContextPPStreamDebuggingAction>"
	
	^ (self forDebugger: aDebugger)
		position: aDebugger streamSelectionInterval last;
		label: 'Run to here (fast)'! !

!GTPPStepToStreamPositionReflectivityAction methodsFor: 'actions' stamp: 'AndreiChis 9/7/2017 23:13'!
attachBreakpoints

	self afterMethodBreakpoint
		targetMethod: PPContext>>#next;
		whenReceiver: [ :aPPContext | aPPContext position = self position ]! !

!GTPPStepToStreamPositionReflectivityAction methodsFor: 'accessing' stamp: 'AndreiChis 3/14/2016 11:17'!
position
	
	^ position! !

!GTPPStepToStreamPositionReflectivityAction methodsFor: 'accessing' stamp: 'AndreiChis 3/14/2016 11:17'!
position: anInteger
	
	position := anInteger! !

!PPParser class methodsFor: '*GT-PetitParserDebugger' stamp: 'AndreiChis 8/13/2013 17:45'!
productionSelectors

	^ #()! !

!PPParser methodsFor: '*GT-PetitParserDebugger' stamp: 'AndreiChis 9/10/2014 18:01'!
debugRoot

	^ self! !

!PPParser methodsFor: '*GT-PetitParserDebugger' stamp: 'AndreiChis 9/3/2014 16:03'!
fullDebug: anObject

	^ self debug: (PPBrowserStream on: anObject)! !

!PPDebugParser methodsFor: '*GT-PetitParserDebugger' stamp: 'AndreiChis 9/10/2014 18:03'!
debugRoot
	"Assume PPDebugParser contains a wrapping parser."	
	^ self children first children first! !

GTGenericStackDebugger subclass: #GTPPDebugger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-PetitParserDebugger'!

!GTPPDebugger class methodsFor: 'accessing' stamp: 'AndreiChis 7/15/2013 16:34'!
defaultTitle

	^ 'PetitParser Debugger'! !

!GTPPDebugger class methodsFor: 'testing' stamp: 'AndreiChis 11/26/2014 14:03'!
handlesContext: aContext

	^ (aContext findContextSuchThat:  [ :ctx | 
				ctx isPPParseRootMethodContext ]) notNil ! !

!GTPPDebugger class methodsFor: 'tools registry' stamp: 'AndreiChis 12/31/2013 21:01'!
register

	self registerToolsOn: Smalltalk tools.! !

!GTPPDebugger class methodsFor: 'tools registry' stamp: 'AndreiChis 7/15/2013 16:40'!
registerToolsOn: registry

	"Add ourselves to registry. See [Smalltalk tools]" 
	registry registerDebugger: self withRank: 55.! !

!GTPPDebugger class methodsFor: 'private' stamp: 'AndreiChis 7/17/2013 23:05'!
sessionClass

	^ GTPPDebugSession ! !

!GTPPDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 9/10/2014 22:36'!
debugViewIn: composite
	(self session stream root respondsTo: #root)
		ifFalse: [ ^ self ].
	(composite dynamic 
		title: 'Result';
		display: [|resultPresentation|
			resultPresentation := GLMCompositePresentation new.
			self session stream root root gtDebugView: resultPresentation.
			resultPresentation last noTitle.
			resultPresentation ])! !

!GTPPDebugger methodsFor: 'building' stamp: 'AndreiChis 3/6/2016 16:21'!
debuggerStructureIn: browser
	
	browser
		row: #stack;
		row: [ :row |
			row 
				column: #code;
				column: #stream ];
		row: #inspector.! !

!GTPPDebugger methodsFor: 'building' stamp: 'AndreiChis 3/6/2016 16:29'!
debuggerTransmissionsIn: browser

	super debuggerTransmissionsIn: browser.
	
	browser transmit
		from: #stack port: #entity;
		to: #stream;
		when: [ :aSession | aSession notNil ];
		andShow: [ :aComposite | self streamIn: aComposite ].
	! !

!GTPPDebugger methodsFor: 'building presentations' stamp: 'JanKurs 1/29/2015 18:35'!
exampleIn: aComposite forSession: aSession forParser: parser

	aComposite text
		title: 'Example';
		useExplicitNotNil;
		display: [
			parser example.
		];
		act: [:text | text update] icon: GLMUIThemeExtraIcons glamorousRefresh entitled: 'Generate another one'! !

!GTPPDebugger methodsFor: 'building presentations' stamp: 'JanKurs 1/29/2015 18:35'!
firstIn: aComposite forSession: aSession forParser: parser

	aComposite list
		title: 'First';
		useExplicitNotNil;
		display: [ 
			parser firstSet.
		];
		format: [ :p | p displayName ]! !

!GTPPDebugger methodsFor: 'building presentations' stamp: 'JanKurs 1/29/2015 18:47'!
followIn: aComposite forSession: aSession forParser: parser
	
	aComposite list
		title: 'Follow';
		useExplicitNotNil;
		format: #displayName;
		display: [
			| rootParser |
			rootParser := aSession rootParser.
			rootParser followSets at: parser ifAbsent: [ #() ].
		]! !

!GTPPDebugger methodsFor: 'building presentations' stamp: 'JanKurs 1/29/2015 18:48'!
graphIn: aComposite forSession: aSession forParser: parser
	
	aComposite morph
		title: 'Graph';
		useExplicitNotNil;
		display: [ 
			| morph |
			morph := ScrollPane new.
			morph color: Color white.
			morph scroller addMorph: 	parser 	morphicProduction.
			(morph allMorphs select: [ :each | 
				each class = StringMorph and: [ each color = Color blue ] ]) do: [ :each |
					each on: #click send: #execute to: 
						((GTPPStepToNextNamedProductionAction forDebugger: self)
							production: each contents) ].
			morph ] ! !

!GTPPDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 9/11/2014 19:54'!
inspectorIn: aComposite on: anObject
	
	super inspectorIn: aComposite on: anObject.
	
	"aComposite last title: 'Inspector'.
	self progressIn: aComposite.
	self tallyIn: aComposite.
	self debugViewIn: aComposite."
	^ aComposite! !

!GTPPDebugger methodsFor: 'building actions' stamp: 'AndreiChis 8/8/2013 11:57'!
installStreamActionsFor: aPresentation

	self installActionsForRootPragmas: { #PPStreamDebuggingAction } in: aPresentation! !

!GTPPDebugger methodsFor: 'building presentations' stamp: 'JanKurs 1/29/2015 18:45'!
mapIn: aComposite forSession: aSession forParser: parser
	((parser isKindOf: PPDelegateParser) 
		and: [parser name isNil not]) ifFalse: [ ^ self ].
	self class environment at: #GLMRoassalPresentation ifPresent: [ :cls |
		aComposite roassal
			title: 'Map';
			useExplicitNotNil;
			painting: [ :view |
				(self production: #start from: aSession rootParser class)
					viewAllNamedParsersWithSelection: (Array with: parser name)
					previewing: [:eachParser | self sourceCodeFrom: aSession rootParser class selector: eachParser name ]
					on: view ] ]	
! !

!GTPPDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 3/6/2016 16:29'!
methodCodeIn: aComposite forContext: aContext

	super methodCodeIn: aComposite forContext: aContext.
	aContext ifNotNil: [ 
		self workspaceIn: aComposite forSession: self session forContext: aContext ]
	! !

!GTPPDebugger methodsFor: 'printing/formatting' stamp: 'AndreiChis 3/27/2016 20:31'!
printStackClassColumnForContext: aContext

	^ (self session isPPParser: aContext receiver)
		ifTrue: [ 
			String streamContents: [:stream | 
				
				stream nextPutAll: aContext receiver class name.
				aContext methodClass == aContext receiver class 
					ifFalse: [
						stream nextPut: $(.
						stream nextPutAll: aContext methodClass name.
						stream nextPut: $) ].
				stream nextPut: $(.
				aContext receiver printNameOn: stream.
				stream nextPut: $).
				"stream nextPutAll: '>>'.
				
				str := super printStackClassColumnForContext: aContext.
				str := str allButFirst: (str indexOf: $> ifAbsent: [ -1 ]) + 1.
				stream nextPutAll: str" ]  ]
		ifFalse: [ super printStackClassColumnForContext: aContext ]
	! !

!GTPPDebugger methodsFor: 'private utilities' stamp: 'AndreiChis 8/7/2013 14:03'!
production: selector from: class
	| parser |
	
	parser := class new.
	^ selector isNil 
		ifTrue: [ parser ]
		ifFalse: [ parser productionAt: selector ]! !

!GTPPDebugger methodsFor: 'private utilities' stamp: 'AndreiChis 8/13/2013 17:46'!
productionSelectorsFrom: class

	^ class productionSelectors! !

!GTPPDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 9/3/2014 16:05'!
progressIn: aComposite 
	(self session stream stream respondsTo: #asPositionMorph)
		ifFalse: [ ^ self ].
	aComposite morph 
		title: 'Progress';
		display: [
			| morph |
			morph := ScrollPane new.
			morph color: Color white.  
			morph scroller addMorph: self session stream stream asPositionMorph.
			morph ].! !

!GTPPDebugger methodsFor: 'accessing' stamp: 'JanKurs 1/29/2015 18:05'!
selectedObject

	^ self selectedContext receiver! !

!GTPPDebugger methodsFor: 'private utilities' stamp: 'JanKurs 1/29/2015 18:52'!
sourceCodeFrom: parser inContext: aPPContext 
	| name root |

	name := parser name.
	root := aPPContext root.
	(root isKindOf: PPCompositeParser) ifTrue: [ 
		name ifNotNil: [ 
			^ root class ultimateSourceCodeAt: (name ifNil: [ #start ]) ifAbsent: [ String new ]
		]
	].
	^ ''! !

!GTPPDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 3/6/2016 16:29'!
sourceIn: aComposite forSession: aSession forParser: selectedParser

	aComposite pharoMethod
		title: 'Production';
		useExplicitNotNil;
		display: [ self sourceCodeFrom: selectedParser inContext: self session stream ];
		smalltalkClass: [ aSession rootParser class ]! !

!GTPPDebugger methodsFor: 'building actions' stamp: 'AndreiChis 3/6/2016 16:24'!
stackDebuggingActionsPragmas

	^ super stackDebuggingActionsPragmas, { #PPDebuggingAction }! !

!GTPPDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 11/25/2015 16:42'!
streamIn: composite
	
	composite text
		title: 'Stream';
		when: [ :aSession | aSession stream notNil ];
		format: [ :aSession | aSession stream collection ];
		initialize: [ :aPresentation | aPresentation 
			selectionInterval: (1 to: (self session stream ifNil: [ 0 ] ifNotNil: [ :aStream | aStream position ])) ];
		with: [ :aPresentation | self installStreamActionsFor: aPresentation ]! !

!GTPPDebugger methodsFor: 'accessing' stamp: 'AndreiChis 8/8/2013 11:49'!
streamPane

	^ self browser paneNamed: #stream! !

!GTPPDebugger methodsFor: 'accessing' stamp: 'AndreiChis 8/8/2013 11:51'!
streamSelectionInterval

	^ self selectionIntervalForPane: #stream! !

!GTPPDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 9/10/2014 18:48'!
tallyIn: composite
	(self session stream stream respondsTo: #asFrequencyTable)
		ifFalse: [ ^ self ].
	composite table 
		title: 'Tally';
		column: 'Parser' evaluated: [ :each | each first displayName ];
		column: 'Count' evaluated: [ :each | each second printString ];
		column: 'Percentage (%)' evaluated: [ :each | each third printString ];
		display: [ self session stream stream asFrequencyTable ];
		noSelection;
		showOnly: 50! !

!GTPPDebugger methodsFor: 'printing/formatting' stamp: 'AndreiChis 9/3/2014 14:17'!
textAttributesForStackEntry: aContext

	(self session isPPProduction: aContext receiver) 
		ifTrue: [ ^ {TextEmphasis bold} ].
		
	(self session rootParserContext  == aContext )
		ifTrue: [ ^ {TextEmphasis italic} ].
		
	^ {TextColor gray}! !

!GTPPDebugger methodsFor: 'updating' stamp: 'AndreiChis 11/25/2015 16:44'!
updateBrowser
	super updateBrowser.
	self updateStreamSelectionInterval.! !

!GTPPDebugger methodsFor: 'updating' stamp: 'AndreiChis 8/8/2013 11:49'!
updateStreamSelectionInterval

	(self streamPane port: #selectionInterval) value: (1 to: self session stream position)! !

!GTPPDebugger methodsFor: 'building presentations' stamp: 'JanKurs 1/29/2015 18:37'!
workspaceIn: aComposite forSession: aSession forContext: aContext
	| targetParser  |
	targetParser := (aContext locateTopNamedPPParser) 
		ifNil: [ aSession rootParser ] 
		ifNotNil: [ :parserContext | parserContext receiver ].

	
	self sourceIn: aComposite forSession: aSession forParser: targetParser.
	self graphIn: aComposite forSession: aSession forParser: targetParser.
	self mapIn: aComposite forSession: aSession forParser: targetParser.
	self exampleIn: aComposite forSession: aSession forParser: targetParser.
	self firstIn: aComposite forSession: aSession forParser: targetParser.
	self followIn: aComposite forSession: aSession forParser: targetParser.! !

!PPContext methodsFor: '*GT-PetitParserDebugger' stamp: 'AndreiChis 9/10/2014 18:02'!
debugRoot

	^ self root debugRoot! !
